//
// Internal definitions
//
// Author: mla (7-Feb-2020)
//

#pragma once
#define UNICODE
#define _UNICODE
#include <windows.h>
#include <windowsx.h>
#include <commctrl.h>
#include <commdlg.h>
#include <strsafe.h>
#include <assert.h>

#include "types.h"
#include "rc_ids.h"

#ifdef _MSC_VER
#define NORETURN __declspec(noreturn)
#else
#define NORETURN
#endif

#define ARRAY_SIZE(x) (sizeof x / sizeof(x[0]))

//////////////////////////////////////////////////////////////////////////////
// Globals
//////////////////////////////////////////////////////////////////////////////

extern HINSTANCE g_AppInstance;

//////////////////////////////////////////////////////////////////////////////
// Functions
//////////////////////////////////////////////////////////////////////////////

// db.c
FACE_DAT *dbLoad(HWND parent, const WCHAR *path);
void dbFree(FACE_DAT *db);

// mainwnd.c
void mainInit(void);
HWND mainCreateWindow(void);

// app.c
NORETURN void appWin32Error(DWORD code, const WCHAR *func);
void appWin32Warn(HWND parent, DWORD code, const WCHAR *func);
void appNotifyWindowDestroy(HWND hwnd);
void appSubscribeWindowDestroy(HWND receiver);
void appUnsubscribeWindowDestroy(HWND receiver);

#define APP_WINDOW_DESTROYED    (WM_APP + 0)

// objview.c
void viewDrawIMAGE(HDC hdc, int dx, int dy, int cx, int cy,
                   const IMAGE *image, const PALETTE *palette);

// animdlg.c
void animInit(void);
HWND animCreate(const ANIMATION *anim);

#define ANIMDLG_CLASS_NAME      L"FaceView_AnimationDialog"

#define ANM_SET_ANIM            (WM_USER + 0)

//////////////////////////////////////////////////////////////////////////////
// OBJECT view definitions
//////////////////////////////////////////////////////////////////////////////

#define OBJVIEW_CLASS_NAME      L"FaceView_ObjectView"

// Messages
#define OVM_RESET               (WM_USER + 0)
#define OVM_SET_OBJECT          (WM_USER + 1)

void viewInit(void);
